attribute vec4 Position;
attribute vec4 Normal;
attribute vec4 SourceColor;
 
varying vec4 DestinationColor; // figure out color by nearby pixels

uniform float slide_factor;
uniform float ObjectSize;

uniform mat4 ProjectionModelview;

attribute vec2 TexCoordIn;
varying vec2 TexCoordOut;

uniform vec3 LightDirection;
varying float LightIntensity;
 
void main(void) { 

    DestinationColor = SourceColor;
    
    vec4 size = vec4(1,ObjectSize,ObjectSize,1);
    
    gl_Position = ProjectionModelview * (Position * size);
    
    
    float slide = TexCoordIn.y*ObjectSize - slide_factor;
    
    TexCoordOut = vec2(TexCoordIn.x,slide);
    
    vec4 newNormal = ProjectionModelview * (Normal * size);
    LightIntensity = max(0.0, dot(Normal.xyz,  LightDirection));
}